using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine;
using UnityEngine.SceneManagement;
using System.Linq;
using TMPro;
using UnityEngine.UI;

namespace Mod
{
    public class Mod
    {
        public static void Main()
        {
CategoryBuilder.Create(" BOPE", "", ModAPI.LoadSprite("category icon.png"));       




                        

 ModAPI.Register(
		    new Modification()
			{
                    OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                    NameOverride = "[BOPE] M4A1 Variant 1",
                    DescriptionOverride = " ",
                    NameToOrderByOverride = "5a",
                    CategoryOverride = ModAPI.FindCategory(" BOPE"),
                    ThumbnailOverride = ModAPI.LoadSprite("icons/m4a1icon.png"),
                    AfterSpawn = (Instance) =>
                    {
		       ModAPI.KeepExtraObjects();

		       var M4A1Slide = Instance.transform.Find("Slide");
                       M4A1Slide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("slides/m4a1slide.png", 16f);
                       M4A1Slide.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);
                       M4A1Slide.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";

                        var HK = new GameObject("M4");
                        HK.transform.SetParent(Instance.transform);
                        HK.transform.localPosition = new Vector2(0f, 0f);
                        HK.transform.localScale = new Vector3(1f, 1f);
                        HK.transform.rotation = Instance.transform.rotation;
                        var HKSprite = HK.AddComponent<SpriteRenderer>();
                        HKSprite.sprite = ModAPI.LoadSprite("weapon/m4a1v1.png", 16f);
                        HKSprite.sortingLayerName = "Foreground"; 

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapon/m4a1v1.png", 16f);
                        Instance.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);
                        Instance.FixColliders(); 
                        Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.92f, 0.13f);
		        Instance.GetComponent<FirearmBehaviour>().casingPosition = new Vector2(0.210f,0.100f);  
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.FixColliders();
                        Instance.GetComponent<FirearmBehaviour>().BulletsPerShot = 1;

                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        Instance.GetComponent<FirearmBehaviour>().Automatic = true;
                        Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.13f;

                        firearm.ShotSounds = new AudioClip[]
                        {
                        ModAPI.LoadSound("Sound/m4sound.mp3"),
                        };

                        Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                        customCartridge.name = "5.56×45mm";
                        customCartridge.Damage *= 5f;
                        customCartridge.Recoil *= 4f;
                        customCartridge.ImpactForce *= 5f;
                        firearm.Cartridge = customCartridge;
		    }
                }
            );

 ModAPI.Register(
		    new Modification()
			{
                    OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                    NameOverride = "[BOPE] M4A1 Variant 2",
                    DescriptionOverride = " ",
                    NameToOrderByOverride = "5b",
                    CategoryOverride = ModAPI.FindCategory(" BOPE"),
                    ThumbnailOverride = ModAPI.LoadSprite("icons/m4a1v2icon.png"),
                    AfterSpawn = (Instance) =>
                    {
		       ModAPI.KeepExtraObjects();

		       var M4A1Slide = Instance.transform.Find("Slide");
                       M4A1Slide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("slides/m4a1slide.png", 16f);
                       M4A1Slide.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);
                       M4A1Slide.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";

                        var HK = new GameObject("M4");
                        HK.transform.SetParent(Instance.transform);
                        HK.transform.localPosition = new Vector2(0f, 0f);
                        HK.transform.localScale = new Vector3(1f, 1f);
                        HK.transform.rotation = Instance.transform.rotation;
                        var HKSprite = HK.AddComponent<SpriteRenderer>();
                        HKSprite.sprite = ModAPI.LoadSprite("weapon/m4a1v2.png", 16f);
                        HKSprite.sortingLayerName = "Foreground";

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapon/m4a1v2.png", 16f);
                        Instance.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);
                        Instance.FixColliders(); 
                        Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.92f, 0.13f);
		        Instance.GetComponent<FirearmBehaviour>().casingPosition = new Vector2(0.210f,0.100f);  
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.FixColliders();
                        Instance.GetComponent<FirearmBehaviour>().BulletsPerShot = 1;

                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        Instance.GetComponent<FirearmBehaviour>().Automatic = true;
                        Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.13f;

                        firearm.ShotSounds = new AudioClip[]
                        {
                        ModAPI.LoadSound("Sound/m4sound.mp3"),
                        };

                        Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                        customCartridge.name = "5.56×45mm";
                        customCartridge.Damage *= 5f;
                        customCartridge.Recoil *= 4f;
                        customCartridge.ImpactForce *= 5f;
                        firearm.Cartridge = customCartridge;
		    }
                }
            );

 ModAPI.Register(
		    new Modification()
			{
                    OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                    NameOverride = "[BOPE] IA2 Variant 1",
                    DescriptionOverride = " ",
                    NameToOrderByOverride = "5c",
                    CategoryOverride = ModAPI.FindCategory(" BOPE"),
                    ThumbnailOverride = ModAPI.LoadSprite("icons/ia2icon.png"),
                    AfterSpawn = (Instance) =>
                    {
		       ModAPI.KeepExtraObjects();

		       var IA2Slide = Instance.transform.Find("Slide");
                       IA2Slide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("slides/ia2slide.png", 16f);
                       IA2Slide.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);
                       IA2Slide.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";

                        var HK = new GameObject("IA2");
                        HK.transform.SetParent(Instance.transform);
                        HK.transform.localPosition = new Vector2(0f, 0f);
                        HK.transform.localScale = new Vector3(1f, 1f);
                        HK.transform.rotation = Instance.transform.rotation;
                        var HKSprite = HK.AddComponent<SpriteRenderer>();
                        HKSprite.sprite = ModAPI.LoadSprite("weapon/ia2.png", 16f);
                        HKSprite.sortingLayerName = "Foreground";

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapon/ia2.png", 16f);
                        Instance.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);
                        Instance.FixColliders(); 
                        Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.92f, 0.13f);
		        Instance.GetComponent<FirearmBehaviour>().casingPosition = new Vector2(0.330f,0.100f);  
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.FixColliders();
                        Instance.GetComponent<FirearmBehaviour>().BulletsPerShot = 1;

                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        Instance.GetComponent<FirearmBehaviour>().Automatic = true;
                        Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.14f;

                        firearm.ShotSounds = new AudioClip[]
                        {
                        ModAPI.LoadSound("Sound/ia2sound.mp3"),
                        };

                        Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                        customCartridge.name = "5.56×45mm";
                        customCartridge.Damage *= 6f;
                        customCartridge.Recoil *= 5f;
                        customCartridge.ImpactForce *= 5f;
                        firearm.Cartridge = customCartridge;
		    }
                }
            );

 ModAPI.Register(
		    new Modification()
			{
                    OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                    NameOverride = "[BOPE] IA2 Variant 2",
                    DescriptionOverride = " ",
                    NameToOrderByOverride = "5d",
                    CategoryOverride = ModAPI.FindCategory(" BOPE"),
                    ThumbnailOverride = ModAPI.LoadSprite("icons/ia2v2icon.png"),
                    AfterSpawn = (Instance) =>
                    {
		       ModAPI.KeepExtraObjects();

		       var IA2Slide = Instance.transform.Find("Slide");
                       IA2Slide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("slides/ia2slide.png", 16f);
                       IA2Slide.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);
                       IA2Slide.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";

                        var HK = new GameObject("IA2");
                        HK.transform.SetParent(Instance.transform);
                        HK.transform.localPosition = new Vector2(0f, 0f);
                        HK.transform.localScale = new Vector3(1f, 1f);
                        HK.transform.rotation = Instance.transform.rotation;
                        var HKSprite = HK.AddComponent<SpriteRenderer>();
                        HKSprite.sprite = ModAPI.LoadSprite("weapon/ia2v2.png", 16f);
                        HKSprite.sortingLayerName = "Foreground";

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapon/ia2v2.png", 16f);
                        Instance.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);
                        Instance.FixColliders(); 
                        Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.92f, 0.13f);
		        Instance.GetComponent<FirearmBehaviour>().casingPosition = new Vector2(0.330f,0.100f);  
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.FixColliders();
                        Instance.GetComponent<FirearmBehaviour>().BulletsPerShot = 1;

                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        Instance.GetComponent<FirearmBehaviour>().Automatic = true;
                        Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.14f;

                        firearm.ShotSounds = new AudioClip[]
                        {
                        ModAPI.LoadSound("Sound/ia2sound.mp3"),
                        };

                        Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                        customCartridge.name = "5.56×45mm";
                        customCartridge.Damage *= 6f;
                        customCartridge.Recoil *= 5f;
                        customCartridge.ImpactForce *= 5f;
                        firearm.Cartridge = customCartridge;
		    }
                }
            );

 ModAPI.Register(
		    new Modification()
			{
                    OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                    NameOverride = "[BOPE] MP5",
                    DescriptionOverride = " ",
                    NameToOrderByOverride = "5e",
                    CategoryOverride = ModAPI.FindCategory(" BOPE"),
                    ThumbnailOverride = ModAPI.LoadSprite("icons/mp5icon.png"),
                    AfterSpawn = (Instance) =>
                    {
		       ModAPI.KeepExtraObjects();

		       var MP5Slide = Instance.transform.Find("Slide");
                       MP5Slide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("slides/mp5slide.png", 16f);
                       MP5Slide.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);
                       MP5Slide.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";

                        var HK = new GameObject("IA2");
                        HK.transform.SetParent(Instance.transform);
                        HK.transform.localPosition = new Vector2(0f, 0f);
                        HK.transform.localScale = new Vector3(1f, 1f);
                        HK.transform.rotation = Instance.transform.rotation;
                        var HKSprite = HK.AddComponent<SpriteRenderer>();
                        HKSprite.sprite = ModAPI.LoadSprite("weapon/mp5.png", 16f);
                        HKSprite.sortingLayerName = "Foreground";

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapon/mp5.png", 16f);
                        Instance.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);
                        Instance.FixColliders(); 
                        Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.92f, 0.13f);
		        Instance.GetComponent<FirearmBehaviour>().casingPosition = new Vector2(0.320f,0.100f);  
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.FixColliders();
                        Instance.GetComponent<FirearmBehaviour>().BulletsPerShot = 1;

                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        Instance.GetComponent<FirearmBehaviour>().Automatic = true;
                        Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.12f;

                        firearm.ShotSounds = new AudioClip[]
                        {
                        ModAPI.LoadSound("Sound/mp5sound.mp3"),
                        };

                        Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                        customCartridge.name = "9mm";
                        customCartridge.Damage *= 4f;
                        customCartridge.Recoil *= 4f;
                        customCartridge.ImpactForce *= 3f;
                        firearm.Cartridge = customCartridge;
		    }
                }
            );

 ModAPI.Register(
		    new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Pistol"),
                    NameOverride = "[BOPE] Glock 17",
                    DescriptionOverride = " ",
                    NameToOrderByOverride = "5f",
                    CategoryOverride = ModAPI.FindCategory(" BOPE"),
                    ThumbnailOverride = ModAPI.LoadSprite("icons/glock17icon.png"),
                    AfterSpawn = (Instance) =>
                    {
		       ModAPI.KeepExtraObjects();
						
		       var GlockSlide = Instance.transform.Find("Slide");
                       GlockSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("slides/glock17slide.png", 20f);

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapon/glock17.png", 20f);
                        Instance.FixColliders(); 
                        Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.24f, 0.06f);
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.FixColliders();
                        Instance.GetComponent<FirearmBehaviour>().BulletsPerShot = 1;

                        var firearm = Instance.GetComponent<FirearmBehaviour>();
  
                        firearm.ShotSounds = new AudioClip[]
                        {
                        ModAPI.LoadSound("Sound/glocksound.mp3"),
                        };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                        customCartridge.name = "9mm";
                        customCartridge.Damage *= 3f;
                        customCartridge.Recoil *= 3f;
                        customCartridge.ImpactForce *= 0.9f;
                        firearm.Cartridge = customCartridge;
		    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[BOPE] Beret", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "2a",
                    CategoryOverride = ModAPI.FindCategory(" BOPE"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/bereticon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/beret.png", 17f);
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/beret.png", 17f);
                        prop.armorPoints = 10;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[BOPE] Boonie [Digital Camo]", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "2b",
                    CategoryOverride = ModAPI.FindCategory(" BOPE"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/boonieicon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/boonie.png", 17f);
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/boonie.png", 17f);
                        prop.armorPoints = 10;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[BOPE] Boonie [Black]", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "2c",
                    CategoryOverride = ModAPI.FindCategory(" BOPE"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/boonie2icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/boonie2.png", 17f);
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/boonie2.png", 17f);
                        prop.armorPoints = 10;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[BOPE] ECH Ballistic ", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "2d",
                    CategoryOverride = ModAPI.FindCategory(" BOPE"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/helmetv1icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/helmetv1.png", 17f);
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/helmetv1.png", 17f);
                        prop.armorPoints = 150;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[BOPE] ECH Ballistic [Raised Goggles]", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "2e",
                    CategoryOverride = ModAPI.FindCategory(" BOPE"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/helmetv2icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/helmetv2.png", 17f);
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/helmetv2.png", 17f);
                        prop.armorPoints = 150;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[BOPE] ECH Ballistic [Goggles]", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "2f",
                    CategoryOverride = ModAPI.FindCategory(" BOPE"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/helmetv3icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/helmetv3.png", 17f);
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/helmetv3.png", 17f);
                        prop.armorPoints = 150;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"), 
                    NameOverride = "[BOPE] Vest Variant 1", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "3a",
                    CategoryOverride = ModAPI.FindCategory(" BOPE"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/vesticon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/vest1.png", 12); 

                        int PartCount = 2;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f);                  
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/vest1.png", 12);
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;
                        prop.armorPoints = 350;
                        armor.prop = prop;
                        armor.SetProperties();
                        
                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = ModAPI.LoadSprite("Armor/vest2.png", 12);
                        armProp[0].armorPiece = "MiddleBody";
                        armProp[0].offset = offset;
                        armProp[0].armorTier = 2;
                        armProp[0].scaleOffset = scaleOffset;
                        armProp[0].armorPoints = 350;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"), 
                    NameOverride = "[BOPE] Vest Variant 2", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "3b",
                    CategoryOverride = ModAPI.FindCategory(" BOPE"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/vest2icon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/vest12.png", 12); 

                        int PartCount = 2;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f);                  
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/vest12.png", 12);
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;
                        prop.armorPoints = 350;
                        armor.prop = prop;
                        armor.SetProperties();
                        
                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = ModAPI.LoadSprite("Armor/vest22.png", 12);
                        armProp[0].armorPiece = "MiddleBody";
                        armProp[0].offset = offset;
                        armProp[0].armorTier = 2;
                        armProp[0].scaleOffset = scaleOffset;
                        armProp[0].armorPoints = 350;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"), 
                    NameOverride = "[BOPE] Vest Variant 3", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "3c",
                    CategoryOverride = ModAPI.FindCategory(" BOPE"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/vest3icon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/vest23.png", 12); 

                        int PartCount = 2;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f);                  
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/vest13.png", 12);
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;
                        prop.armorPoints = 350;
                        armor.prop = prop;
                        armor.SetProperties();
                        
                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = ModAPI.LoadSprite("Armor/vest23.png", 12);
                        armProp[0].armorPiece = "MiddleBody";
                        armProp[0].offset = offset;
                        armProp[0].armorTier = 2;
                        armProp[0].scaleOffset = scaleOffset;
                        armProp[0].armorPoints = 350;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"), 
                    NameOverride = "[BOPE] Vest Variant 4", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "3d",
                    CategoryOverride = ModAPI.FindCategory(" BOPE"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/vest4icon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/vest24.png", 12); 

                        int PartCount = 2;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f);                  
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/vest14.png", 12);
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;
                        prop.armorPoints = 350;
                        armor.prop = prop;
                        armor.SetProperties();
                        
                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = ModAPI.LoadSprite("Armor/vest24.png", 12);
                        armProp[0].armorPiece = "MiddleBody";
                        armProp[0].offset = offset;
                        armProp[0].armorTier = 2;
                        armProp[0].scaleOffset = scaleOffset;
                        armProp[0].armorPoints = 350;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"), 
                    NameOverride = "[BOPE] Vest Variant 5", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "3e",
                    CategoryOverride = ModAPI.FindCategory(" BOPE"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/vest5icon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/vest25.png", 12); 

                        int PartCount = 2;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f);                  
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/vest15.png", 12);
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;
                        prop.armorPoints = 350;
                        armor.prop = prop;
                        armor.SetProperties();
                        
                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = ModAPI.LoadSprite("Armor/vest25.png", 12);
                        armProp[0].armorPiece = "MiddleBody";
                        armProp[0].offset = offset;
                        armProp[0].armorTier = 2;
                        armProp[0].scaleOffset = scaleOffset;
                        armProp[0].armorPoints = 350;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"), 
                    NameOverride = "[BOPE] Vest Variant 6", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "3f",
                    CategoryOverride = ModAPI.FindCategory(" BOPE"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/vest6icon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/vest26.png", 12); 

                        int PartCount = 2;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f);                  
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/vest16.png", 12);
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;
                        prop.armorPoints = 350;
                        armor.prop = prop;
                        armor.SetProperties();
                        
                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = ModAPI.LoadSprite("Armor/vest26.png", 12);
                        armProp[0].armorPiece = "MiddleBody";
                        armProp[0].offset = offset;
                        armProp[0].armorTier = 2;
                        armProp[0].scaleOffset = scaleOffset;
                        armProp[0].armorPoints = 350;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"), 
                    NameOverride = "[BOPE] Patch Variant 1", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "3g",
                    CategoryOverride = ModAPI.FindCategory(" BOPE"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/patch1icon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/patch1.png", 20); 

                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f);                  
                        prop.armorPiece = "UpperArmFront";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/patch1.png", 20);
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;
                        prop.armorPoints = 10;
                        armor.prop = prop;
                        armor.SetProperties();
                        
                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"), 
                    NameOverride = "[BOPE] Patch Variant 2", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "3h",
                    CategoryOverride = ModAPI.FindCategory(" BOPE"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/patch2icon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/patch2.png", 20); 

                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f);                  
                        prop.armorPiece = "UpperArmFront";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/patch2.png", 20);
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;
                        prop.armorPoints = 10;
                        armor.prop = prop;
                        armor.SetProperties();
                        
                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"), 
                    NameOverride = "[BOPE] Belt [Black]", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "4a",
                    CategoryOverride = ModAPI.FindCategory(" BOPE"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/belticon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/belt.png", 12); 

                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f);                  
                        prop.armorPiece = "LowerBody";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/belt.png", 12);
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;
                        prop.armorPoints = 350;
                        armor.prop = prop;
                        armor.SetProperties();
                        
                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"), 
                    NameOverride = "[BOPE] Belt [Digital Camo]", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "4b",
                    CategoryOverride = ModAPI.FindCategory(" BOPE"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/belt2icon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/belt2.png", 12); 

                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f);                  
                        prop.armorPiece = "LowerBody";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/belt2.png", 12);
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;
                        prop.armorPoints = 350;
                        armor.prop = prop;
                        armor.SetProperties();
                        
                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

 ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), 
                    NameOverride = "[BOPE] Combat Uniform [Digital camo]",
                    DescriptionOverride = " ", 
                    NameToOrderByOverride = "1A",
                    CategoryOverride = ModAPI.FindCategory(" BOPE"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/outfitsicon.png"),
                    AfterSpawn = (Instance) => 
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();

                        var Head = Instance.transform.Find("Head").gameObject;

                        Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 12;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
                        {
                            ModAPI.LoadTexture("Outfit/variant1.png"),
                            ModAPI.LoadTexture("Outfit/variant1v2.png"),
                            ModAPI.LoadTexture("Outfit/variant1v3.png"),
                        };
                    }
                }
            );    

 ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), 
                    NameOverride = "[BOPE] Combat Uniform [Digital camo / Short Sleeve]",
                    DescriptionOverride = " ", 
                    NameToOrderByOverride = "1B",
                    CategoryOverride = ModAPI.FindCategory(" BOPE"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/outfitsicon.png"),
                    AfterSpawn = (Instance) => 
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();

                        var Head = Instance.transform.Find("Head").gameObject;

                        Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 12;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
                        {
                            ModAPI.LoadTexture("Outfit/variant2.png"),
                            ModAPI.LoadTexture("Outfit/variant2v2.png"),
                            ModAPI.LoadTexture("Outfit/variant2v3.png"),
                        };
                    }
                }
            );          

 ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), 
                    NameOverride = "[BOPE] Combat Uniform [Black]",
                    DescriptionOverride = " ", 
                    NameToOrderByOverride = "1B",
                    CategoryOverride = ModAPI.FindCategory(" BOPE"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/outfits2icon.png"),
                    AfterSpawn = (Instance) => 
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();

                        var Head = Instance.transform.Find("Head").gameObject;

                        Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 12;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
                        {
                            ModAPI.LoadTexture("Outfit/variant3.png"),
                            ModAPI.LoadTexture("Outfit/variant3v2.png"),
                            ModAPI.LoadTexture("Outfit/variant3v3.png"),
                        };
                    }
                }
            );       

 ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), 
                    NameOverride = "[BOPE] Combat Uniform [Black / Short Sleeve]",
                    DescriptionOverride = " ", 
                    NameToOrderByOverride = "1B",
                    CategoryOverride = ModAPI.FindCategory(" BOPE"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/outfits2icon.png"),
                    AfterSpawn = (Instance) => 
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();

                        var Head = Instance.transform.Find("Head").gameObject;

                        Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 12;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
                        {
                            ModAPI.LoadTexture("Outfit/variant4.png"),
                            ModAPI.LoadTexture("Outfit/variant4v2.png"),
                            ModAPI.LoadTexture("Outfit/variant4v3.png"),
                        };
                    }
                }
            );    
         
/////////////////////////////////////////////////////////////////////////////

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[BOPE] PMAG [Prop]", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "9zg",
                    CategoryOverride = ModAPI.FindCategory(" BOPE"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/magicon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Prop/mag.png", 16f); 
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[BOPE] PMAG [Prop / No Bullet]", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "9zh",
                    CategoryOverride = ModAPI.FindCategory(" BOPE"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/mag2icon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Prop/mag2.png", 16f); 
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[BOPE] M4A1 Variant 1 [Prop]", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "9za",
                    CategoryOverride = ModAPI.FindCategory(" BOPE"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/m4a1v1propicon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Prop/m4a1v1prop.png", 16f); 
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[BOPE] M4A1 Variant 2 [Prop]", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "9zb",
                    CategoryOverride = ModAPI.FindCategory(" BOPE"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/m4a1v2propicon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Prop/m4a1v2prop.png", 16f); 
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[BOPE] IA2 Variant 1 [Prop]", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "9zc",
                    CategoryOverride = ModAPI.FindCategory(" BOPE"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/ia2propicon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Prop/ia2prop.png", 16f); 
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[BOPE] IA2 Variant 2 [Prop]", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "9zd",
                    CategoryOverride = ModAPI.FindCategory(" BOPE"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/ia2v2propicon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Prop/ia2v2prop.png", 16f); 
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[BOPE] IA2 Mag [Prop]", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "9zi",
                    CategoryOverride = ModAPI.FindCategory(" BOPE"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/ia2magicon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Prop/ia2mag.png", 16f); 
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[BOPE] IA2 Mag [Prop / No Bullet]", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "9zj",
                    CategoryOverride = ModAPI.FindCategory(" BOPE"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/ia2v2magicon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Prop/ia2v2mag.png", 16f); 
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[BOPE] Glock 17 Mag [Prop]", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "9zk",
                    CategoryOverride = ModAPI.FindCategory(" BOPE"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/17magicon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Prop/17mag.png", 20f); 
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[BOPE] Glock 17 Mag [Prop / No Bullet]", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "9zl",
                    CategoryOverride = ModAPI.FindCategory(" BOPE"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/17v2magicon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Prop/17v2mag.png", 20f); 
                        Instance.FixColliders();
                    }
                }
            );


ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[BOPE] Glock 17 [Prop]", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "9ze",
                    CategoryOverride = ModAPI.FindCategory(" BOPE"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/glock17propicon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Prop/glock17prop.png", 20f); 
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[BOPE] MP5 [Prop]", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "9zf",
                    CategoryOverride = ModAPI.FindCategory(" BOPE"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/mp5propicon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Prop/mp5prop.png", 16f); 
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[BOPE] MP5 Mag [Prop]", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "9zm",
                    CategoryOverride = ModAPI.FindCategory(" BOPE"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/mp5magicon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Prop/mp5mag.png", 16f); 
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[BOPE] MP5 Mag [Prop / No Bullet]", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "9zn",
                    CategoryOverride = ModAPI.FindCategory(" BOPE"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/mp5v2magicon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Prop/mp5v2mag.png", 16f); 
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"), 
                    NameOverride = "[BOPE] Map [Prop]", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "9zo",
                    CategoryOverride = ModAPI.FindCategory(" BOPE"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/thumbicon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Discarded/thumbc.png", 1.93f); 
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
			}
			Instance.FixColliders();
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Discarded/thumb.png", 1.93f); 
                        Instance.AddComponent<FreezeBehaviour>();
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";

                    }
                }
            );


















      



       
              





        }


public class MultipleSpriteHumanBehaviour : MonoBehaviour
    {
        public Texture2D[] Textures = new Texture2D[0];
        public PersonBehaviour person;
        public int CurrentTexture = -2;
        public int Scale = 3;

        void Start()
        {
            SetTexture();
        }

        public void SetTexture()
        {
            if (Textures.Length == 0)
                return;

            if(CurrentTexture == -2)
            {
                CurrentTexture = UnityEngine.Random.Range(0, Textures.Length);
            }
            person.SetBodyTextures(Textures[CurrentTexture], null, null, Scale);
            for (int i = 0; i < person.Limbs.Length; i++)
            {
                person.Limbs[i].gameObject.GetComponent<PhysicalBehaviour>().RefreshOutline();
            }
        }
}    }
}
